DEFINT A-Z
'$INCLUDE: 'esp!.bi'
'***************************************************************************
'This code is Copyright 1991-93, PAROLE Software.  You may make any changes
'to this code for your own personal use.  If you wish to distribute any
'program that incorporates this code, please notify me in writing and include a
'copy of the changes.  There will be no royalty charges.  I hope that this code
'will help aspiring programmers to write BBS door program.   ESP! is a full
'functioning program.  It requires The DoorFrame version for Visual Basic for
'DOS.  To use any other version, you may have to make slight changes to the
'source code.
'***************************************************************************

  '****************************************************************************
  '                             VARIABLES
  '****************************************************************************
  'Right&         Correct number of guesses
  'Try%           Actual number of guesses
  'Response$      Input from IN.PUT statements
  'Card%          The Integer or card created by the RND routine
  'Tr$            Try% converted to String$ variable
  'Corr$          Right& converted to a String$ variable
  'Ver$           String$ of the Version of program
  'LogCheck$      Line 5 of the .CFG file checks to determine if Log to be created
  'DonorCheck$    Line 6 of the .CFG file checks to see if there is Door Donor
  'SetAttempt%    Line 7 of the .CFG file sets number of allowed attempts per game
  'SerialNum&     Line 8 Registered Serial number
  '******************************************************
  '***  Written By:  Dennis Maidon                    ***
  '***               9411 Buffalo Rd                  ***
  '***               Clayton, NC  27520               ***
  '***               (919) 965-3600                   ***
  '******************************************************
     ProgName$ = "ESP!"
     Version$ = " v2.3"
     ExeName$ = "ESP!"
     TimeOut% = 240
     ProgVer$ = "[EVALUATION COPY]"
     ScreenDir$ = CURDIR$ + "\SCREENS"
'************************************************************************
     INITIALIZE
     RANDOMIZE TIMER
     ON ERROR GOTO ERR.ROUTINE
     DETECT.ANSI
     PriorMode% = Mode%       'save the original user Mode%
     INPUT #1, LogCheck$, DonorCheck$, SetAttempt%, SerialNum&
     CLOSE #1
     'always close the CFG file as soon as possible
'************************************************************************
     GetRegisterInfo SerialNum&
     SendOpeningScreen

     IF Reg% THEN
          ClearBuffer 0
          ENTER
     ELSE
          ProgType$ = "Please ask %^" + SysOpFirst$ + "^ to register this program."
          DIS.PLAY "Pausing for 10 seconds...", LWHITE, BLACK, 0, 0, 18, 1, 0, 1, 0, 0
          DIS.PLAY ProgType$, LWHITE, BLACK, 0, 0, 19, 1, 0, 1, 0, 1
          GoPause% = 11
          GOSUB TimePause
          ON TIMER(1) GOSUB TimePause
          TIMER ON
          DO UNTIL GoPause% <= 0: LOOP
          TIMER OFF
     END IF

     CLRSCRN BLACK
     IF Reg% THEN
          DIS.PLAY " " + BBSSys$ + " ", LWHITE, RED, 0, 0, 17, 1, 0, 1, 0, 0
          DIS.PLAY " Your SysOp has registered this program. ", BLACK, GREEN, 0, 0, 18, 1, 0, 1, 0, 0
          DIS.PLAY " " + SysOpName$ + " ", LWHITE, RED, 0, 0, 19, 1, 0, 1, 0, 0
     ELSE
          DIS.PLAY " Please ask ^" + SysOpFirst$ + "^ to register " + ProgName$ + " ", LYELLOW, BLACK, 0, 0, 18, 1, 0, 1, 0, 1
     END IF
     GetInstruct
     PlayDiceGuess

  '**************************************************************************
  '                         Game Routines
  '**************************************************************************
GameStart:

     CLRSCRN BLACK
     DIS.PLAY " Would you like to play again? (}y}/}N}) :", LGREEN, BLACK, 0, 0, 5, 3, 0, 0, 0, 1
     IN.PUT 1, 60, BLACK, BLACK, 1, "", BLACK, BLACK, 0, 0, 0
     CheckIdleTime Response$
     IF UCASE$(Response$) = "Y" THEN
          GOTO GameStart
     ELSE
          WriteUserLog
          SHOW.BLT "Y"
          CLRSCRN BLACK
          Mode% = PriorMode%
          TimeAdjust% = 50
          EXIT.DOOR "Y"
     END IF

     EXIT.DOOR "Y"

ERR.ROUTINE:
     ERRORS ERR, ERL
     END

TimePause:

     GoPause% = GoPause% - 1
     CLREOL 18, 52, BLACK
     DIS.PLAY LTRIM$(STR$(GoPause%)), LRED, BLACK, 0, 0, 18, 53, 0, 0, 0, 0
     RETURN

STATIC SUB CheckIdleTime (a$)

     IF a$ = "-1" THEN
          Mode% = PriorMode%
          CLRSCRN BLACK
          EXIT.DOOR "Y"
     END IF

     'this routine checks the RESPONSE$ from the IN.PUT routine.  When the
     'IN.PUT times out, it send a "-1" response.

END SUB

STATIC SUB Draw.Screen (Card%)

     SHARED Try%, Right&
     BOX.IT 6, 60, 8, 64, 0, BLACK, YELLOW, YELLOW, YELLOW, 32, -1, "", BLACK, YELLOW
     SELECT CASE Card%
          CASE 1
               DIS.PLAY " O ", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
          CASE 2
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
          CASE 3
               DIS.PLAY " O ", BLACK, YELLOW, 0, 0, 6, 61, 0, 0, 1, 0
               DIS.PLAY " O ", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
               DIS.PLAY " O ", BLACK, YELLOW, 0, 0, 8, 61, 0, 0, 1, 0
          CASE 4
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 6, 61, 0, 0, 1, 0
               DIS.PLAY "   ", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 8, 61, 0, 0, 1, 0
          CASE 5
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 6, 61, 0, 0, 1, 0
               DIS.PLAY " O ", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 8, 61, 0, 0, 1, 0
          CASE 6
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 6, 61, 0, 0, 1, 0
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 8, 61, 0, 0, 1, 0
          CASE 7
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 6, 61, 0, 0, 1, 0
               DIS.PLAY "OOO", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 8, 61, 0, 0, 1, 0
          CASE 8
               DIS.PLAY "OOO", BLACK, YELLOW, 0, 0, 6, 61, 0, 0, 1, 0
               DIS.PLAY "O O", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
               DIS.PLAY "OOO", BLACK, YELLOW, 0, 0, 8, 61, 0, 0, 1, 0
          CASE 9
               DIS.PLAY "OOO", BLACK, YELLOW, 0, 0, 6, 61, 0, 0, 1, 0
               DIS.PLAY "OOO", BLACK, YELLOW, 0, 0, 7, 61, 0, 0, 1, 0
               DIS.PLAY "OOO", BLACK, YELLOW, 0, 0, 8, 61, 0, 0, 1, 0
     END SELECT
     Tr$ = LTRIM$(STR$(Try%))
     Corr$ = LTRIM$(STR$(Right&))
     TimeL$ = LTRIM$(STR$(TimeLeft%))
     DIS.PLAY " " + Tr$ + " ", LCYAN, BLACK, 0, 0, 10, 26, 0, 0, 0, 0
     DIS.PLAY " " + Corr$ + " ", LCYAN, BLACK, 0, 0, 12, 26, 0, 0, 0, 0
     SELECT CASE TimeLeft%
          CASE IS >= 5
               DIS.PLAY " " + TimeL$ + " ", LCYAN, BLACK, 0, 0, 14, 26, 0, 0, 0, 0
          CASE ELSE
               DIS.PLAY " " + TimeL$ + " ", LCYAN, BLACK, 1, 0, 14, 26, 0, 0, 0, 0
     END SELECT

END SUB

STATIC SUB DrawGuessMainScreen ()

     SHARED ProgVer$, DonorCheck$, SetAttempt%, Try%

     AttemptsLeft$ = LTRIM$(STR$(SetAttempt% - Try%))

     CLRSCRN BLACK
     IF Reg% THEN
          MenuTitle$ = BBSSys$ + " Presents " + ProgName$ + Version$
     ELSE
          MenuTitle$ = "PAROLE Software Presents " + ProgName$ + Version$
     END IF
     BOX.IT 1, 1, 22, 79, 2, LCYAN, RED, LWHITE, BLACK, 0, 0, MenuTitle$, LWHITE, RED
     BOX.IT 5, 59, 9, 65, 1, BLACK, YELLOW, YELLOW, YELLOW, 32, 0, "", BLACK, YELLOW
     DIS.PLAY " Attempts Left : ", LYELLOW, MAGENTA, 0, 0, 5, 3, 0, 0, 0, 0
     DIS.PLAY " Number of Guesses : ", LWHITE, RED, 0, 0, 10, 5, 0, 0, 0, 0
     DIS.PLAY " Correct Guesses   : ", LWHITE, RED, 0, 0, 12, 5, 0, 0, 0, 0
     DIS.PLAY " Time Remaining    : ", LWHITE, RED, 0, 0, 14, 5, 0, 0, 0, 0

     DIS.PLAY AttemptsLeft$, GREEN, BLACK, 0, 0, 5, 21, 0, 0, 0, 0
     DIS.PLAY "^ SysOp :^ " + SysOpName$, LYELLOW, BLACK, 0, 0, 16, 20, 0, 1, 0, 1
     DIS.PLAY ProgVer$, LGREEN, BLACK, 0, 0, 17, 20, 0, 1, 0, 1
     DIS.PLAY BBSSys$, LYELLOW, BLACK, 0, 0, 18, 20, 0, 1, 0, 0
     IF UCASE$(LEFT$(DonorCheck$, 1)) <> "N" THEN
          DIS.PLAY ProgName$ + " `is sponsored by` " + DonorCheck$, LYELLOW, BLACK, 0, 0, 19, 20, 0, 1, 0, 1
     END IF

END SUB

STATIC SUB GetInstruct ()

     IN.PUT 1, 60, BLACK, BLACK, 1, "Do you need instructions? (}y}/}N}) ", LGREEN, BLACK, 5, 1, 0
     CheckIdleTime Response$

     IF UCASE$(Response$) = "Y" THEN
          IF Mode% THEN
               SEND ScreenDir$ + "\INSTRUCT.ANS", 1, 1
          ELSE
               SEND ScreenDir$ + "\INSTRUCT.ASC", 1, 1
          END IF
     END IF

END SUB

STATIC SUB GetRegisterInfo (a&)

     SHARED ProgVer$, BBSREG$, ProgType$

     FOR Position = 1 TO LEN(BBSSys$)
          Sum& = Sum& + ASC(MID$(UCASE$(BBSSys$), Position, 1))
     NEXT Position
     FirstMult% = ASC(MID$(UCASE$(BBSSys$), 5, 1))
     FirstAdd% = ASC(MID$(UCASE$(SysOpFirst$), 1, 1))
     SerNum& = ((Sum& + FirstAdd%) * ((LEN(BBSSys$))) + 1) * FirstMult%

     SELECT CASE a&
          CASE SerNum&
               ProgVer$ = "[}REGISTERED VERSION}]"
               ProgType$ = BBSSys$
               Reg% = -1
          CASE ELSE
               ProgVer$ = "[%}EVALUATION COPY}]"
               Reg% = 0
     END SELECT
'*********************
Reg% = -1
'Reg%=0
     'Since ESP! is a "FREEBIE", I have set the REG% variable to be TRUE
'*********************
END SUB

STATIC SUB PlayDiceGuess ()

     SHARED ProgVer$, DonorCheck$, Try%, Right&, SetAttempt%

     Try% = 0
     Right& = 0
     DrawGuessMainScreen
     DO
           Draw.Screen (Card%)
          'Notice this will loop as long as the user (or LineNoise <g>) gives invalid
          'responses.
          DIS.PLAY "Which Die will appear next? (^1^-^9^ [^Q^]uit [^C^]olor [^R^]edraw):", LYELLOW, BLACK, 0, 0, 3, 3, 0, 0, 0, 1
          DO
               IN.PUT 1, 60, BLACK, BLACK, 1, "", LYELLOW, BLACK, 3, 62, 0
               CheckIdleTime Response$
          LOOP WHILE INSTR("123456789ACQR", UCASE$(Response$)) = 0 OR Response$ = ""

          SELECT CASE UCASE$(Response$)
               CASE "C"
                    IF Mode% THEN
                         Mode% = 0
                    ELSE
                         Mode% = -1
                    END IF
                    DrawGuessMainScreen
               CASE "R"
                    DrawGuessMainScreen
               CASE "Q"
                    CLRSCRN BLACK
                    Mode% = PriorMode%
                    EXIT.DOOR "Y"
               CASE "A"
                    DIS.PLAY " Dedicated to my wife Brenda, who allowed me the time. ", LWHITE, BLUE, 0, 0, 21, 3, 0, 1, 0, 0
               CASE ELSE
                    Try% = Try% + 1
                    Card% = INT((9 - 1 + 1) * RND + 1)
                    IF VAL(Response$) = Card% THEN
                         Right& = Right& + 1
                    END IF
                    IF Guess% = Card% THEN
                         Right& = Right& + 1
                    END IF
                    AttemptsLeft$ = LTRIM$(STR$(SetAttempt% - Try%))
                    CLRMOL 5, 20, 5, BLACK
                    DIS.PLAY AttemptsLeft$, GREEN, BLACK, 0, 0, 5, 21, 0, 0, 0, 0
          END SELECT
     LOOP UNTIL Try% = SetAttempt%
     Draw.Screen (Card%)
     ClearBuffer 0
     ENTER
     MAKE.BLT (Right&)
END SUB

STATIC SUB SendOpeningScreen ()

     CLRSCRN BLACK

     IF Mode% THEN
          SEND ScreenDir$ + "\WELCOME.ANS", 0, 1
     ELSE
          SEND ScreenDir$ + "\WELCOME.ASC", 0, 1
     END IF

END SUB

STATIC SUB WriteUserLog ()

     IF LEFT$(UCASE$(LogCheck$), 1) = "L" THEN
          LogFile = FREEFILE
          OPEN "ESP!.LOG" FOR APPEND SHARED AS LogFile
          Format1$ = "NAME: \                      \ NODE: ###  CORRECT: ###"
          Format2$ = "DATE: &    TIME: &"
          PRINT #LogFile, USING Format1$; Name$; NodeNum%; Right&
          PRINT #LogFile, USING Format2$; FORMAT$(NOW, "mmmm d, yyyy"); TIME$
          PRINT #LogFile, STRING$(60, 176)
          CLOSE LogFile
     END IF

END SUB

